// vagPrevDoc.cpp : CVagPrevDoc class definition
//

#include "stdafx.h"
#include "vagPrev.h"

#include "vagPrevDoc.h"
#include "vagPrevView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CVagPrevDoc

IMPLEMENT_DYNCREATE(CVagPrevDoc, CDocument)

BEGIN_MESSAGE_MAP(CVagPrevDoc, CDocument)
	//{{AFX_MSG_MAP(CVagPrevDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void endianConv( char* data )
{
	char tmp;

	tmp = *data;
	*data = *(data+3);
	*(data+3) = tmp;
	tmp = *(data+1);
	*(data+1) = *(data+2);
	*(data+2) = tmp;

	return;
}

/////////////////////////////////////////////////////////////////////////////
// CVagPrevDoc class : constructor / destructor

CVagPrevDoc::CVagPrevDoc()
{

}

CVagPrevDoc::~CVagPrevDoc()
{
}

BOOL CVagPrevDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CVagPrevDoc : serialize

void CVagPrevDoc::Serialize(CArchive& ar)
{
	char vagHeader[48];	
	long* size;
	long* freq;
	unsigned char* vagData;

	if (ar.IsLoading())
	{
		ar.Read( vagHeader, 48 );

		endianConv( vagHeader+12 );
		size = (long*)(vagHeader+12);
		vagData = new unsigned char[ *size ];
		ar.Read( vagData, 48+(*size) );

		endianConv( vagHeader+16 );
		freq = (long*)( vagHeader+16 );
		
		//laodVagĂяo
		POSITION pos = GetFirstViewPosition();
		CView* pEv = GetNextView(pos);
		((CVagPrevView*)pEv)->m_freq = *freq;		
		((CVagPrevView*)pEv)->loadVag( *size, vagData );
	}
}

/////////////////////////////////////////////////////////////////////////////
// CVagPrevDoc class diagnostic

#ifdef _DEBUG
void CVagPrevDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CVagPrevDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

