// vagPrevView.h
//
/////////////////////////////////////////////////////////////////////////////
#include "Libspu.h"

#if !defined(AFX_VAGPREVVIEW_H__54291CCF_5EBF_11D1_9F31_0020183116E1__INCLUDED_)
#define AFX_VAGPREVVIEW_H__54291CCF_5EBF_11D1_9F31_0020183116E1__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CVagPrevView : public CFormView
{
protected:
	CVagPrevView();
	DECLARE_DYNCREATE(CVagPrevView);

public:
	//{{AFX_DATA(CVagPrevView)
	enum { IDD = IDD_VAGPREV_FORM };
	CButton	m_btnInform;
	CSliderCtrl	m_sldPitch;
	CButton	m_btnKeyOff;
	CButton	m_btnKeyOn;
	UINT	m_editPitch;
	CString	m_combADSR;
	BOOL	m_checkRev;
	//}}AFX_DATA

// attribute
public:
	BOOL isLoaded;
	long m_freq;
	
	CVagPrevDoc* GetDocument();
	virtual void OnInitialUpdate();

// operation
public:

// override
	//{{AFX_VIRTUAL(CVagPrevView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

    SpuVoiceAttr s_attr;

// implementation
public:
	virtual ~CVagPrevView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	void loadVag( long gVagSize, unsigned char* gVagData );

protected:
	void initializeSpu();
	void initializeRev();
	void setNote(unsigned short note);
	void setNoteAttr();


// generated message map function
protected:
	//{{AFX_MSG(CVagPrevView)
	afx_msg void OnKeyOn();
	afx_msg void OnKeyOff();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnBtnSet();
	afx_msg void OnInform();
	afx_msg void OnCheckRev();
	afx_msg void OnButton2();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG
inline CVagPrevDoc* CVagPrevView::GetDocument()
   { return (CVagPrevDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}

#endif // !defined(AFX_VAGPREVVIEW_H__54291CCF_5EBF_11D1_9F31_0020183116E1__INCLUDED_)
